//+---------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                           Logging.mqh |
//|                                                                                                                                   hoz |
//|                                                                                                                                       |
//+---------------------------------------------------------------------------------------------------------------------------------------+
#ifndef LOGGING_H
#define LOGGING_H

#property copyright "hoz"
#property link      ""
#property strict
// ========================================================     ===========================================================+
#include    <HOZ_Code\Classes\BaseInfo.mqh>
//+=======================================================================================================================================+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                                                                                |
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+=======================================================================================================================================+
class Logging
{
   private:
      bool   PrintUP;      //   
      bool   CommentUP;    //     
      bool   NeedLogs;     //       ()   
   protected:
      string LibName;
   public:
      //----   
             Logging (void);
            ~Logging (void);
      //---- 
      void   SetPrintUP (const bool fb_PrintUP);
      void   SetCommentUP (const bool fb_CommentUP);
      void   SetNeedLogs (const bool ib_NeedLogs);
      //---- 
      bool   GetPrintUP() const;
      bool   GetCommentUP() const;
      //---- 
      void   WriteLog (string fs_Txt, bool fb_NeedLogs = false, bool fb_PrintUP = false, bool fb_CommentUP = false);
      void   Printing (string fs_Text, bool fb_PrintUP = true, bool fb_CommentUP = true);
};
//----    Logging
Logging CLogging;
//=========================================================================================================================================
//  . ====================================================================================================================
Logging::Logging (void) {
   SetPrintUP (ib_PrintUP);
   SetCommentUP (ib_CommentUP);
   SetNeedLogs (ib_NeedLogs);
}
//=========================================================================================================================================
//  . =====================================================================================================================
Logging::~Logging (void) {
}
//+=======================================================================================================================================+
//|                                                                                                                                |
//+=======================================================================================================================================+
//---- SetPrintPermission
Logging::SetPrintUP (const bool fb_PrintUP)
{
   PrintUP = fb_PrintUP;
}
//---- SetCommentPermission
Logging::SetCommentUP (const bool fb_CommentUP)
{
   CommentUP = fb_CommentUP;
}
//---- SetNeedLogs
Logging::SetNeedLogs(const bool fb_NeedLogs)
{
   NeedLogs = fb_NeedLogs;
}
//+=======================================================================================================================================+
//|                                                                                                                                |
//+=======================================================================================================================================+
//---- GetPrintPermission
bool Logging::GetPrintUP (void) const
{
   return (PrintUP);
}
//---- GetCommentPermission
bool Logging::GetCommentUP (void) const
{
   return (CommentUP);
}
//=========================================================================================================================================
// 1.1  Log-. ====================================================================================================================
Logging::WriteLog (string  fs_Txt,                          // ,     log-
                   bool    fb_NeedLogs = false,             //       ()   
                   bool    fb_PrintUP = false,              //   
                   bool    fb_CommentUP = false)            //     
{
   static datetime ldt_NewDayOpen = 0;
   static string   ls_FileName = "";
   datetime        ldt_CurrDayOpen = iTime (Symbol(), NULL, PERIOD_D1);
   //----        
   if (ldt_NewDayOpen != ldt_CurrDayOpen)
   {
      ls_FileName = StringConcatenate (WindowExpertName(), "_", Symbol(), "_", Period(), "-", Month(), "-", Day(), ".log");
      ldt_NewDayOpen = ldt_CurrDayOpen;
   }
   int handle = FileOpen (ls_FileName, FILE_READ|FILE_WRITE|FILE_CSV, "/t");
   
   FileSeek (handle, 0, SEEK_END);
   FileWrite (handle, StringConcatenate (TimeToStr (TimeCurrent(), TIME_DATE|TIME_SECONDS), ": ", fs_Txt));
   FileClose (handle);
   
   if (fb_NeedLogs == true)
       Printing (fs_Txt, fb_PrintUP, fb_CommentUP);
}
//=========================================================================================================================================
// 1.2     ()   . ===================================================================================
Logging::Printing (string  fs_Text,                               //   
                   bool    fb_PrintUP = true,                     //   
                   bool    fb_CommentUP = true)                   //     
{
   LibName = "Logging";

   if (StringLen (fs_Text) > 0)
   {
      if (LibName != "") fs_Text = StringConcatenate (LibName, " => ", fs_Text);

      if (fb_PrintUP)
          Print (fs_Text);

      if (fb_CommentUP)
          Comment (fs_Text);
   }
   //----  
   //fs_Txt = "";

   return;
}

#endif